Index: trunk/include/VBox/pci.h
===================================================================
--- trunk/include/VBox/pci.h	(revision 36075)
+++ trunk/include/VBox/pci.h	(revision 36079)
@@ -547,4 +547,7 @@
 DECLINLINE(uint8_t)  PCIDevGetByte(PPCIDEVICE pPciDev, uint32_t uOffset)
 {
+#ifdef PCIDEVICEINT_DECLARED
+    Assert((pPciDev->Int.s.fFlags & PCIDEV_FLAG_PASSTHROUGH) == 0);
+#endif
     return pPciDev->config[uOffset];
 }
@@ -557,4 +560,7 @@
 DECLINLINE(uint16_t) PCIDevGetWord(PPCIDEVICE pPciDev, uint32_t uOffset)
 {
+#ifdef PCIDEVICEINT_DECLARED
+    Assert((pPciDev->Int.s.fFlags & PCIDEV_FLAG_PASSTHROUGH) == 0);
+#endif
     uint16_t u16Value = *(uint16_t*)&pPciDev->config[uOffset];
     return RT_H2LE_U16(u16Value);
@@ -568,4 +574,7 @@
 DECLINLINE(uint32_t) PCIDevGetDWord(PPCIDEVICE pPciDev, uint32_t uOffset)
 {
+#ifdef PCIDEVICEINT_DECLARED
+    Assert((pPciDev->Int.s.fFlags & PCIDEV_FLAG_PASSTHROUGH) == 0);
+#endif
     uint32_t u32Value = *(uint32_t*)&pPciDev->config[uOffset];
     return RT_H2LE_U32(u32Value);
@@ -579,4 +588,7 @@
 DECLINLINE(uint64_t) PCIDevGetQWord(PPCIDEVICE pPciDev, uint32_t uOffset)
 {
+#ifdef PCIDEVICEINT_DECLARED
+    Assert((pPciDev->Int.s.fFlags & PCIDEV_FLAG_PASSTHROUGH) == 0);
+#endif
     uint64_t u64Value = *(uint64_t*)&pPciDev->config[uOffset];
     return RT_H2LE_U64(u64Value);
@@ -920,88 +932,82 @@
 
 #ifdef PCIDEVICEINT_DECLARED
-/** @todo r=bird: These are internal methods and should start with lowercase
- *  prefix as well as including the 'Dev' bit: s/PCI\(Set|Get\)/pciDev\1/
- *
- *  Also: s/uFlags/fFlags/
- */
-
-DECLINLINE(void) PCISetRequestedDevfunc(PPCIDEVICE pDev)
-{
-    pDev->Int.s.uFlags |= PCIDEV_FLAG_REQUESTED_DEVFUNC;
-}
-
-DECLINLINE(void) PCIClearRequestedDevfunc(PPCIDEVICE pDev)
-{
-    pDev->Int.s.uFlags &= ~PCIDEV_FLAG_REQUESTED_DEVFUNC;
-}
-
-DECLINLINE(bool) PCIIsRequestedDevfunc(PPCIDEVICE pDev)
-{
-    return (pDev->Int.s.uFlags & PCIDEV_FLAG_REQUESTED_DEVFUNC) != 0;
-}
-
-DECLINLINE(void) PCISetPci2PciBridge(PPCIDEVICE pDev)
-{
-    pDev->Int.s.uFlags |= PCIDEV_FLAG_PCI_TO_PCI_BRIDGE;
-}
-
-DECLINLINE(bool) PCIIsPci2PciBridge(PPCIDEVICE pDev)
-{
-    return (pDev->Int.s.uFlags & PCIDEV_FLAG_PCI_TO_PCI_BRIDGE) != 0;
-}
-
-DECLINLINE(void) PCISetPciExpress(PPCIDEVICE pDev)
-{
-    pDev->Int.s.uFlags |= PCIDEV_FLAG_PCI_EXPRESS_DEVICE;
-}
-
-DECLINLINE(bool) PCIIsPciExpress(PPCIDEVICE pDev)
-{
-    return (pDev->Int.s.uFlags & PCIDEV_FLAG_PCI_EXPRESS_DEVICE) != 0;
-}
-
-DECLINLINE(void) PCISetMsiCapable(PPCIDEVICE pDev)
-{
-    pDev->Int.s.uFlags |= PCIDEV_FLAG_MSI_CAPABLE;
-}
-
-DECLINLINE(void) PCIClearMsiCapable(PPCIDEVICE pDev)
-{
-    pDev->Int.s.uFlags &= ~PCIDEV_FLAG_MSI_CAPABLE;
-}
-
-DECLINLINE(bool) PCIIsMsiCapable(PPCIDEVICE pDev)
-{
-    return (pDev->Int.s.uFlags & PCIDEV_FLAG_MSI_CAPABLE) != 0;
-}
-
-DECLINLINE(void) PCISetMsixCapable(PPCIDEVICE pDev)
-{
-    pDev->Int.s.uFlags |= PCIDEV_FLAG_MSIX_CAPABLE;
-}
-
-DECLINLINE(void) PCIClearMsixCapable(PPCIDEVICE pDev)
-{
-    pDev->Int.s.uFlags &= ~PCIDEV_FLAG_MSIX_CAPABLE;
-}
-
-DECLINLINE(bool) PCIIsMsixCapable(PPCIDEVICE pDev)
-{
-    return (pDev->Int.s.uFlags & PCIDEV_FLAG_MSIX_CAPABLE) != 0;
-}
-
-DECLINLINE(void) PCISetPassthrough(PPCIDEVICE pDev)
-{
-    pDev->Int.s.uFlags |= PCIDEV_FLAG_PASSTHROUGH;
-}
-
-DECLINLINE(void) PCIClearPassthrough(PPCIDEVICE pDev)
-{
-    pDev->Int.s.uFlags &= ~PCIDEV_FLAG_PASSTHROUGH;
-}
-
-DECLINLINE(bool) PCIIsPassthrough(PPCIDEVICE pDev)
-{
-    return (pDev->Int.s.uFlags & PCIDEV_FLAG_PASSTHROUGH) != 0;
+DECLINLINE(void) pciDevSetRequestedDevfunc(PPCIDEVICE pDev)
+{
+    pDev->Int.s.fFlags |= PCIDEV_FLAG_REQUESTED_DEVFUNC;
+}
+
+DECLINLINE(void) pciDevClearRequestedDevfunc(PPCIDEVICE pDev)
+{
+    pDev->Int.s.fFlags &= ~PCIDEV_FLAG_REQUESTED_DEVFUNC;
+}
+
+DECLINLINE(bool) pciDevIsRequestedDevfunc(PPCIDEVICE pDev)
+{
+    return (pDev->Int.s.fFlags & PCIDEV_FLAG_REQUESTED_DEVFUNC) != 0;
+}
+
+DECLINLINE(void) pciDevSetPci2PciBridge(PPCIDEVICE pDev)
+{
+    pDev->Int.s.fFlags |= PCIDEV_FLAG_PCI_TO_PCI_BRIDGE;
+}
+
+DECLINLINE(bool) pciDevIsPci2PciBridge(PPCIDEVICE pDev)
+{
+    return (pDev->Int.s.fFlags & PCIDEV_FLAG_PCI_TO_PCI_BRIDGE) != 0;
+}
+
+DECLINLINE(void) pciDevSetPciExpress(PPCIDEVICE pDev)
+{
+    pDev->Int.s.fFlags |= PCIDEV_FLAG_PCI_EXPRESS_DEVICE;
+}
+
+DECLINLINE(bool) pciDevIsPciExpress(PPCIDEVICE pDev)
+{
+    return (pDev->Int.s.fFlags & PCIDEV_FLAG_PCI_EXPRESS_DEVICE) != 0;
+}
+
+DECLINLINE(void) pciDevSetMsiCapable(PPCIDEVICE pDev)
+{
+    pDev->Int.s.fFlags |= PCIDEV_FLAG_MSI_CAPABLE;
+}
+
+DECLINLINE(void) pciDevClearMsiCapable(PPCIDEVICE pDev)
+{
+    pDev->Int.s.fFlags &= ~PCIDEV_FLAG_MSI_CAPABLE;
+}
+
+DECLINLINE(bool) pciDevIsMsiCapable(PPCIDEVICE pDev)
+{
+    return (pDev->Int.s.fFlags & PCIDEV_FLAG_MSI_CAPABLE) != 0;
+}
+
+DECLINLINE(void) pciDevSetMsixCapable(PPCIDEVICE pDev)
+{
+    pDev->Int.s.fFlags |= PCIDEV_FLAG_MSIX_CAPABLE;
+}
+
+DECLINLINE(void) pciDevClearMsixCapable(PPCIDEVICE pDev)
+{
+    pDev->Int.s.fFlags &= ~PCIDEV_FLAG_MSIX_CAPABLE;
+}
+
+DECLINLINE(bool) pciDevIsMsixCapable(PPCIDEVICE pDev)
+{
+    return (pDev->Int.s.fFlags & PCIDEV_FLAG_MSIX_CAPABLE) != 0;
+}
+
+DECLINLINE(void) pciDevSetPassthrough(PPCIDEVICE pDev)
+{
+    pDev->Int.s.fFlags |= PCIDEV_FLAG_PASSTHROUGH;
+}
+
+DECLINLINE(void) pciDevClearPassthrough(PPCIDEVICE pDev)
+{
+    pDev->Int.s.fFlags &= ~PCIDEV_FLAG_PASSTHROUGH;
+}
+
+DECLINLINE(bool) pciDevIsPassthrough(PPCIDEVICE pDev)
+{
+    return (pDev->Int.s.fFlags & PCIDEV_FLAG_PASSTHROUGH) != 0;
 }
 
Index: trunk/include/VBox/rawpci.h
===================================================================
--- trunk/include/VBox/rawpci.h	(revision 36075)
+++ trunk/include/VBox/rawpci.h	(revision 36079)
@@ -87,5 +87,5 @@
     uint64_t             iRegionSize;
     RTR3PTR              pvAddressR3;
-    RTR0PTR              pvAddressR0;    
+    RTR0PTR              pvAddressR0;
 } PCIRAWREQUNMAPREGION;
 
@@ -126,5 +126,5 @@
 {
     /* in */
-    RTGCPHYS             Address;
+    RTR0PTR              Address;
     PCIRAWMEMLOC         Value;
 } PCIRAWREQMMIOWRITE;
@@ -134,5 +134,5 @@
 {
     /* in */
-    RTGCPHYS             Address;
+    RTR0PTR              Address;
     /* inout (Value.cb is in) */
     PCIRAWMEMLOC         Value;
@@ -296,5 +296,5 @@
                                              RTHCPHYS       RegionStart,
                                              uint64_t       u64RegionSize,
-                                             RTR0PTR        *pRegionBase));
+                                             RTR0PTR        *pRegionBaseR0));
 
     /**